unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OmegaTimer, OmegaFont, OmegaInput, OmegaImageList, OmegaScreen,
  OmegaSprite;

type
  TKostka=class(TSprite)
  protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );virtual;
    procedure Draw;override;
    procedure Move(const MoveCount:single);override;
  end;

  TRoslina=class(TKostka)
    k,
    w:integer;  //kolumna i wiersz zaczepienia pnia rosliny
   protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );virtual;
    procedure Move(const MoveCount:single);override;
    procedure onCollision(const Sprite:Tsprite;const colX,colY:integer);override;
  end;

  TGracz=class(TSprite)
  public
    fPokryty,
    fKolizja:boolean;
    function  Pokryty(x0,y0,_width,_height:single):boolean;
    procedure MoznaIsc;
  protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );
     procedure Move(const MoveCount:single);override;
     procedure Draw;override;
  end;

  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaInput1: TOmegaInput;
    OmegaFont1: TOmegaFont;
    OmegaTimer1: TOmegaTimer;
    OmegaSprite1: TOmegaSprite;
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    procedure TworzSwiat;
//    procedure Klawiszologia;
  public
    { Public declarations }
  end;

var
  SkokX,
  SkokY   :single;
  Form1   : TForm1;
  Gracz   :TGracz;
  Roslina :TRoslina;
implementation

{$R *.DFM}
//*******BLOK KOSTEK WIATA*****************************
constructor TKostka.Create(const AParent: TOmegaSprite;
                           const ImageListItem: TImageListItem;
                           const IdKlatka:Integer
                       );
begin
 inherited Create(AParent);
 Image := ImageListItem;
 ImageIndex:=IdKlatka;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
end;
procedure TKostka.Move(const MoveCount:single);
begin
 inherited Move(MoveCount);
 x:=x+SkokX;
 y:=y+SkokY;
end;
procedure TKostka.Draw;
begin
 if ImageIndex<0 then exit;
 inherited Draw;
end;
//*******KONIEC BLOKU KOSTEK WIATA*********************
//*******BLOK KLASY ROSLINA*****************************
constructor TRoslina.Create(const AParent: TOmegaSprite;
                           const ImageListItem: TImageListItem;
                           const IdKlatka:Integer
                       );
begin
 inherited Create(AParent,ImageListItem,IdKlatka);
 Image := ImageListItem;
 ImageIndex:=IdKlatka;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
end;

procedure TRoslina.Move(const MoveCount:single);
begin
 inherited Move(MoveCount);
end;
procedure TRoslina.onCollision(const Sprite:Tsprite;const colX,colY:integer);
begin
  if (Sprite is TGracz)then begin
    TGracz(Sprite).fKolizja:=true;
    TGracz(Sprite).fPokryty:=TGracz(Sprite).Pokryty(x,y,Image.TileWidth,Image.TileHeight);
  end;
end;

//*******KONIEC BLOKU ROSLINA***************************
//*******BLOK KLASY GRACZ*******************************
procedure TGracz.MoznaIsc;
begin
 //Sterowanie Graczem
 if oisUp in Form1.OmegaInput1.keyboard.states    then//idz do gory
    SkokY:=SkokY+1;
 if oisDown in Form1.OmegaInput1.keyboard.states  then//idz w d
    SkokY:=SkokY-1;
 if oisRight in Form1.OmegaInput1.keyboard.states then//idz w prawo
    SkokX:=SkokX-1;
 if oisLeft in Form1.OmegaInput1.keyboard.states  then//idz w lewo
    SkokX:=SkokX+1;
end;

procedure TGracz.Move(const MoveCount:single);
begin
 inherited Move(MoveCount);
end;
function  TGracz.Pokryty(x0,y0,_width,_height:single):boolean;
begin
 result:=false;
 if (x+2>X0)and
    (y+2>y0)and
    (x-2+Image.TileWidth <x0+_width)and
    (y-2+Image.TileHeight<y0+_height)
    then result:=true;
end;
procedure TGracz.Draw;
begin
 if not fKolizja then inherited Draw
 else
 Image.Draw(Round(x),Round(y),0,0.5,0.5,1,1,255,0,255{255,255},155,ImageIndex,0);
end;
constructor TGracz.Create(const AParent: TOmegaSprite;
                          const ImageListItem: TImageListItem;
                          const IdKlatka:Integer
                       );
begin
 inherited Create(AParent);
 Image        := ImageListItem;
 ImageIndex   :=idKlatka;
 width        :=Image.TileWidth;
 height       :=Image.TileHeight;
 DoCollision  :=true;
 DoPixelCheck :=true;
end;
//*******KONIEC BLOKU KLASY GRACZ***********************
procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin
 OmegaInput1.Update;
 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
  OmegaScreen1.ToggleFullScreen;

 Gracz.MoznaIsc;
 if not omegascreen1.CanDraw then exit;
 OmegaScreen1.ClearScreen(0,0,0,0);
 OmegaScreen1.BeginRender;
 OmegaSprite1.Collision;

 OmegaSprite1.Dead;
 OmegaSprite1.Move(OmegaTimer1.DeltaSecs);
 OmegaSprite1.Draw;
 OmegaFont1.Print(0,20,'F2 zmiana trybu wywietlania aplikacji');
 OmegaFont1.Print(0,40,'FPS: '+IntToStr(OmegaTimer1.FPS));

 OmegaScreen1.EndRender;

 SkokX:=0;
 SkokY:=0;
 Gracz.fKolizja:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OmegaScreen1.Init;
  OmegaScreen1.SetHWnd(self.handle);
  OmegaFont1.Init;
  OmegaFont1.CreateFont('Arial',8,[]);
  OmegaFont1.Color:=OmegaColor(255,0,0);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OmegaTimer1.Enabled:=false;
  OmegaSprite1.Dead;
  OmegaScreen1.FreeOnRelease;
  if OmegaScreen1.FullScreen then  OmegaScreen1.ToggleFullScreen;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 TworzSwiat;
 OmegaTimer1.Enabled:=true;
end;
procedure TForm1.TworzSwiat;
const
 las:array[0..4]of integer=
    (2,3,4,5,6);
var
 i,k,w,idObraz:integer;
begin
 Randomize;
 for i:=0 to 10 do
 begin
  idObraz:=las[RAndom(high(las))];
  if idObraz>-1 then
  begin
   Roslina:=TRoslina.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[idObraz],0);
   Roslina.x:=RAndom(800);
   Roslina.y:=RAndom(400);
   Roslina.z:=0;
   Roslina.DoCollision :=true;//false;
   Roslina.DoPixelCheck:=true;
  end;
 end;
 Gracz:=TGracz.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[1],0);
 Gracz.X:=320;
 Gracz.Y:=240;
 Gracz.Z:=1;
end;
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key= 27 then close;
end;

end.
